Index: /trunk/src/emx/src/lib/msun/i387/e_exp.S
===================================================================
--- /trunk/src/emx/src/lib/msun/i387/e_exp.S	(revision 2015)
+++ /trunk/src/emx/src/lib/msun/i387/e_exp.S	(revision 2016)
@@ -39,5 +39,5 @@
 
 /* e^x = 2^(x * log2(e)) */
-ENTRY(exp)
+STDENTRY(exp)
 	/*
 	 * If x is +-Inf, then the subtraction would give Inf-Inf = NaN.
@@ -70,5 +70,5 @@
 	fst	%st(2)
 	fsubrp				/* fract(x * log2(e)) */
-	f2xm1				/* 2^(fract(x * log2(e))) - 1 */ 
+	f2xm1				/* 2^(fract(x * log2(e))) - 1 */
 	fld1
 	faddp				/* 2^(fract(x * log2(e))) */
Index: /trunk/src/emx/src/lib/msun/i387/e_fmod.S
===================================================================
--- /trunk/src/emx/src/lib/msun/i387/e_fmod.S	(revision 2015)
+++ /trunk/src/emx/src/lib/msun/i387/e_fmod.S	(revision 2016)
@@ -38,5 +38,5 @@
 RCSID("$FreeBSD: src/lib/msun/i387/e_fmod.S,v 1.8 2005/02/04 14:08:32 das Exp $")
 
-ENTRY(fmod)
+STDENTRY(fmod)
 	fldl	12(%esp)
 	fldl	4(%esp)
Index: /trunk/src/emx/src/lib/msun/i387/e_log.S
===================================================================
--- /trunk/src/emx/src/lib/msun/i387/e_log.S	(revision 2015)
+++ /trunk/src/emx/src/lib/msun/i387/e_log.S	(revision 2016)
@@ -38,5 +38,5 @@
 RCSID("$FreeBSD: src/lib/msun/i387/e_log.S,v 1.7 2005/02/04 14:08:32 das Exp $")
 
-ENTRY(log)
+STDENTRY(log)
 	fldln2
 	fldl	4(%esp)
Index: /trunk/src/emx/src/lib/msun/i387/e_log10.S
===================================================================
--- /trunk/src/emx/src/lib/msun/i387/e_log10.S	(revision 2015)
+++ /trunk/src/emx/src/lib/msun/i387/e_log10.S	(revision 2016)
@@ -38,5 +38,5 @@
 RCSID("$FreeBSD: src/lib/msun/i387/e_log10.S,v 1.7 2005/02/04 14:08:32 das Exp $")
 
-ENTRY(log10)
+STDENTRY(log10)
 	fldlg2
 	fldl	4(%esp)
Index: /trunk/src/emx/src/lib/msun/i387/e_log10f.S
===================================================================
--- /trunk/src/emx/src/lib/msun/i387/e_log10f.S	(revision 2015)
+++ /trunk/src/emx/src/lib/msun/i387/e_log10f.S	(revision 2016)
@@ -9,5 +9,5 @@
 /* RCSID("$NetBSD: e_log10f.S,v 1.1 1996/07/03 16:50:22 jtc Exp $") */
 
-ENTRY(log10f)
+STDENTRY(log10f)
 	fldlg2
 	flds	4(%esp)
Index: /trunk/src/emx/src/lib/msun/i387/e_logf.S
===================================================================
--- /trunk/src/emx/src/lib/msun/i387/e_logf.S	(revision 2015)
+++ /trunk/src/emx/src/lib/msun/i387/e_logf.S	(revision 2016)
@@ -9,5 +9,5 @@
 /* RCSID("$NetBSD: e_logf.S,v 1.2 1996/07/06 00:15:45 jtc Exp $") */
 
-ENTRY(logf)
+STDENTRY(logf)
 	fldln2
 	flds	4(%esp)
Index: /trunk/src/emx/src/lib/msun/i387/e_remainder.S
===================================================================
--- /trunk/src/emx/src/lib/msun/i387/e_remainder.S	(revision 2015)
+++ /trunk/src/emx/src/lib/msun/i387/e_remainder.S	(revision 2016)
@@ -38,5 +38,5 @@
 RCSID("$FreeBSD: src/lib/msun/i387/e_remainder.S,v 1.8 2005/02/04 14:08:32 das Exp $")
 
-ENTRY(remainder)
+STDENTRY(remainder)
 	fldl	12(%esp)
 	fldl	4(%esp)
Index: /trunk/src/emx/src/lib/msun/i387/e_remainderf.S
===================================================================
--- /trunk/src/emx/src/lib/msun/i387/e_remainderf.S	(revision 2015)
+++ /trunk/src/emx/src/lib/msun/i387/e_remainderf.S	(revision 2016)
@@ -9,5 +9,5 @@
 /* RCSID("$NetBSD: e_remainderf.S,v 1.2 1995/05/08 23:49:47 jtc Exp $") */
 
-ENTRY(remainderf)
+STDENTRY(remainderf)
 	flds	8(%esp)
 	flds	4(%esp)
Index: /trunk/src/emx/src/lib/msun/i387/e_scalbf.S
===================================================================
--- /trunk/src/emx/src/lib/msun/i387/e_scalbf.S	(revision 2015)
+++ /trunk/src/emx/src/lib/msun/i387/e_scalbf.S	(revision 2016)
@@ -9,5 +9,5 @@
 /* RCSID("$NetBSD: e_scalbf.S,v 1.1 1996/07/03 16:50:24 jtc Exp $") */
 
-ENTRY(scalbf)
+STDENTRY(scalbf)
 	flds	8(%esp)
 	flds	4(%esp)
Index: /trunk/src/emx/src/lib/msun/i387/e_sqrt.S
===================================================================
--- /trunk/src/emx/src/lib/msun/i387/e_sqrt.S	(revision 2015)
+++ /trunk/src/emx/src/lib/msun/i387/e_sqrt.S	(revision 2016)
@@ -38,5 +38,5 @@
 RCSID("$FreeBSD: src/lib/msun/i387/e_sqrt.S,v 1.7 2005/02/04 14:08:32 das Exp $")
 
-ENTRY(sqrt)
+STDENTRY(sqrt)
 	fldl	4(%esp)
 	fsqrt
Index: /trunk/src/emx/src/lib/msun/i387/e_sqrtf.S
===================================================================
--- /trunk/src/emx/src/lib/msun/i387/e_sqrtf.S	(revision 2015)
+++ /trunk/src/emx/src/lib/msun/i387/e_sqrtf.S	(revision 2016)
@@ -9,5 +9,5 @@
 /* RCSID("$NetBSD: e_sqrtf.S,v 1.2 1995/05/08 23:50:14 jtc Exp $") */
 
-ENTRY(sqrtf)
+STDENTRY(sqrtf)
 	flds	4(%esp)
 	fsqrt
Index: /trunk/src/emx/src/lib/msun/i387/fenv.c
===================================================================
--- /trunk/src/emx/src/lib/msun/i387/fenv.c	(revision 2015)
+++ /trunk/src/emx/src/lib/msun/i387/fenv.c	(revision 2016)
@@ -27,4 +27,5 @@
  */
 
+#include "namespace.h"
 #include <sys/cdefs.h>
 #include <sys/types.h>
@@ -85,5 +86,5 @@
 
 int
-fesetexceptflag(const fexcept_t *flagp, int excepts)
+_STD(fesetexceptflag)(const fexcept_t *flagp, int excepts)
 {
 	fenv_t env;
@@ -106,5 +107,5 @@
 
 int
-feraiseexcept(int excepts)
+_STD(feraiseexcept)(int excepts)
 {
 	fexcept_t ex = excepts;
@@ -116,5 +117,5 @@
 
 int
-fegetenv(fenv_t *envp)
+_STD(fegetenv)(fenv_t *envp)
 {
 	int control, mxcsr;
@@ -135,5 +136,5 @@
 
 int
-feholdexcept(fenv_t *envp)
+_STD(feholdexcept)(fenv_t *envp)
 {
 	int mxcsr;
@@ -152,5 +153,5 @@
 
 int
-feupdateenv(const fenv_t *envp)
+_STD(feupdateenv)(const fenv_t *envp)
 {
 	int mxcsr, status;
Index: /trunk/src/emx/src/lib/msun/i387/s_ceil.S
===================================================================
--- /trunk/src/emx/src/lib/msun/i387/s_ceil.S	(revision 2015)
+++ /trunk/src/emx/src/lib/msun/i387/s_ceil.S	(revision 2016)
@@ -38,5 +38,5 @@
 RCSID("$FreeBSD: src/lib/msun/i387/s_ceil.S,v 1.7 1999/08/28 00:06:11 peter Exp $")
 
-ENTRY(ceil)
+STDENTRY(ceil)
 	pushl	%ebp
 	movl	%esp,%ebp
Index: /trunk/src/emx/src/lib/msun/i387/s_ceilf.S
===================================================================
--- /trunk/src/emx/src/lib/msun/i387/s_ceilf.S	(revision 2015)
+++ /trunk/src/emx/src/lib/msun/i387/s_ceilf.S	(revision 2016)
@@ -9,5 +9,5 @@
 /* RCSID("$NetBSD: s_ceilf.S,v 1.3 1995/05/08 23:52:44 jtc Exp $") */
 
-ENTRY(ceilf)
+STDENTRY(ceilf)
 	pushl	%ebp
 	movl	%esp,%ebp
Index: /trunk/src/emx/src/lib/msun/i387/s_ceill.S
===================================================================
--- /trunk/src/emx/src/lib/msun/i387/s_ceill.S	(revision 2015)
+++ /trunk/src/emx/src/lib/msun/i387/s_ceill.S	(revision 2016)
@@ -7,5 +7,5 @@
 __FBSDID("$FreeBSD: src/lib/msun/i387/s_ceill.S,v 1.1 2005/04/16 21:12:55 das Exp $")
 
-ENTRY(ceill)
+STDENTRY(ceill)
 	pushl	%ebp
 	movl	%esp,%ebp
Index: /trunk/src/emx/src/lib/msun/i387/s_copysign.S
===================================================================
--- /trunk/src/emx/src/lib/msun/i387/s_copysign.S	(revision 2015)
+++ /trunk/src/emx/src/lib/msun/i387/s_copysign.S	(revision 2016)
@@ -38,5 +38,5 @@
 RCSID("$FreeBSD: src/lib/msun/i387/s_copysign.S,v 1.6 1999/08/28 00:06:11 peter Exp $")
 
-ENTRY(copysign)
+STDENTRY(copysign)
 	movl	16(%esp),%edx
 	andl	$0x80000000,%edx
Index: /trunk/src/emx/src/lib/msun/i387/s_copysignf.S
===================================================================
--- /trunk/src/emx/src/lib/msun/i387/s_copysignf.S	(revision 2015)
+++ /trunk/src/emx/src/lib/msun/i387/s_copysignf.S	(revision 2016)
@@ -9,5 +9,5 @@
 /* RCSID("$NetBSD: s_copysignf.S,v 1.3 1995/05/08 23:53:25 jtc Exp $") */
 
-ENTRY(copysignf)
+STDENTRY(copysignf)
 	movl	8(%esp),%edx
 	andl	$0x80000000,%edx
Index: /trunk/src/emx/src/lib/msun/i387/s_copysignl.S
===================================================================
--- /trunk/src/emx/src/lib/msun/i387/s_copysignl.S	(revision 2015)
+++ /trunk/src/emx/src/lib/msun/i387/s_copysignl.S	(revision 2016)
@@ -7,5 +7,5 @@
 __FBSDID("$FreeBSD: src/lib/msun/i387/s_copysignl.S,v 1.1 2005/04/16 21:12:55 das Exp $")
 
-ENTRY(copysignl)
+STDENTRY(copysignl)
 	movl	24(%esp),%edx
 	andl	$0x8000,%edx
Index: /trunk/src/emx/src/lib/msun/i387/s_cos.S
===================================================================
--- /trunk/src/emx/src/lib/msun/i387/s_cos.S	(revision 2015)
+++ /trunk/src/emx/src/lib/msun/i387/s_cos.S	(revision 2016)
@@ -38,5 +38,5 @@
 RCSID("$FreeBSD: src/lib/msun/i387/s_cos.S,v 1.6 1999/08/28 00:06:12 peter Exp $")
 
-ENTRY(cos)
+STDENTRY(cos)
 	fldl	4(%esp)
 	fcos
Index: /trunk/src/emx/src/lib/msun/i387/s_floor.S
===================================================================
--- /trunk/src/emx/src/lib/msun/i387/s_floor.S	(revision 2015)
+++ /trunk/src/emx/src/lib/msun/i387/s_floor.S	(revision 2016)
@@ -38,5 +38,5 @@
 RCSID("$FreeBSD: src/lib/msun/i387/s_floor.S,v 1.7 1999/08/28 00:06:12 peter Exp $")
 
-ENTRY(floor)
+STDENTRY(floor)
 	pushl	%ebp
 	movl	%esp,%ebp
Index: /trunk/src/emx/src/lib/msun/i387/s_floorf.S
===================================================================
--- /trunk/src/emx/src/lib/msun/i387/s_floorf.S	(revision 2015)
+++ /trunk/src/emx/src/lib/msun/i387/s_floorf.S	(revision 2016)
@@ -9,5 +9,5 @@
 /* RCSID("$NetBSD: s_floorf.S,v 1.3 1995/05/09 00:04:32 jtc Exp $") */
 
-ENTRY(floorf)
+STDENTRY(floorf)
 	pushl	%ebp
 	movl	%esp,%ebp
Index: /trunk/src/emx/src/lib/msun/i387/s_floorl.S
===================================================================
--- /trunk/src/emx/src/lib/msun/i387/s_floorl.S	(revision 2015)
+++ /trunk/src/emx/src/lib/msun/i387/s_floorl.S	(revision 2016)
@@ -7,5 +7,5 @@
 __FBSDID("$FreeBSD: src/lib/msun/i387/s_floorl.S,v 1.1 2005/04/16 21:12:55 das Exp $")
 
-ENTRY(floorl)
+STDENTRY(floorl)
 	pushl	%ebp
 	movl	%esp,%ebp
Index: /trunk/src/emx/src/lib/msun/i387/s_llrint.S
===================================================================
--- /trunk/src/emx/src/lib/msun/i387/s_llrint.S	(revision 2015)
+++ /trunk/src/emx/src/lib/msun/i387/s_llrint.S	(revision 2016)
@@ -26,7 +26,7 @@
 
 #include <machine/asm.h>
-__FBSDID("$FreeBSD: src/lib/msun/i387/s_llrint.S,v 1.1 2005/01/11 23:10:53 das Exp $"); 
+__FBSDID("$FreeBSD: src/lib/msun/i387/s_llrint.S,v 1.1 2005/01/11 23:10:53 das Exp $");
 	
-ENTRY(llrint)
+STDENTRY(llrint)
 	fldl	4(%esp)
 	subl	$8,%esp
Index: /trunk/src/emx/src/lib/msun/i387/s_llrintf.S
===================================================================
--- /trunk/src/emx/src/lib/msun/i387/s_llrintf.S	(revision 2015)
+++ /trunk/src/emx/src/lib/msun/i387/s_llrintf.S	(revision 2016)
@@ -28,5 +28,5 @@
 __FBSDID("$FreeBSD: src/lib/msun/i387/s_llrintf.S,v 1.1 2005/04/16 21:12:55 das Exp $")
 	
-ENTRY(llrintf)
+STDENTRY(llrintf)
 	flds	4(%esp)
 	subl	$8,%esp
Index: /trunk/src/emx/src/lib/msun/i387/s_logb.S
===================================================================
--- /trunk/src/emx/src/lib/msun/i387/s_logb.S	(revision 2015)
+++ /trunk/src/emx/src/lib/msun/i387/s_logb.S	(revision 2016)
@@ -38,5 +38,5 @@
 RCSID("$FreeBSD: src/lib/msun/i387/s_logb.S,v 1.7 2000/06/06 12:12:36 bde Exp $")
 
-ENTRY(logb)
+STDENTRY(logb)
 	fldl	4(%esp)
 	fxtract
Index: /trunk/src/emx/src/lib/msun/i387/s_logbf.S
===================================================================
--- /trunk/src/emx/src/lib/msun/i387/s_logbf.S	(revision 2015)
+++ /trunk/src/emx/src/lib/msun/i387/s_logbf.S	(revision 2016)
@@ -9,5 +9,5 @@
 /* RCSID("$NetBSD: s_logbf.S,v 1.3 1995/05/09 00:15:12 jtc Exp $") */
 
-ENTRY(logbf)
+STDENTRY(logbf)
 	flds	4(%esp)
 	fxtract
Index: /trunk/src/emx/src/lib/msun/i387/s_lrint.S
===================================================================
--- /trunk/src/emx/src/lib/msun/i387/s_lrint.S	(revision 2015)
+++ /trunk/src/emx/src/lib/msun/i387/s_lrint.S	(revision 2016)
@@ -26,7 +26,7 @@
 
 #include <machine/asm.h>
-__FBSDID("$FreeBSD: src/lib/msun/i387/s_lrint.S,v 1.1 2005/01/11 23:10:53 das Exp $"); 
+__FBSDID("$FreeBSD: src/lib/msun/i387/s_lrint.S,v 1.1 2005/01/11 23:10:53 das Exp $");
 	
-ENTRY(lrint)
+STDENTRY(lrint)
 	fldl	4(%esp)
 	subl	$4,%esp
Index: /trunk/src/emx/src/lib/msun/i387/s_lrintf.S
===================================================================
--- /trunk/src/emx/src/lib/msun/i387/s_lrintf.S	(revision 2015)
+++ /trunk/src/emx/src/lib/msun/i387/s_lrintf.S	(revision 2016)
@@ -28,5 +28,5 @@
 __FBSDID("$FreeBSD: src/lib/msun/i387/s_lrintf.S,v 1.1 2005/04/16 21:12:55 das Exp $")
 	
-ENTRY(lrintf)
+STDENTRY(lrintf)
 	flds	4(%esp)
 	subl	$4,%esp
Index: /trunk/src/emx/src/lib/msun/i387/s_remquo.S
===================================================================
--- /trunk/src/emx/src/lib/msun/i387/s_remquo.S	(revision 2015)
+++ /trunk/src/emx/src/lib/msun/i387/s_remquo.S	(revision 2016)
@@ -30,7 +30,7 @@
 
 #include <machine/asm.h>
-__FBSDID("$FreeBSD: src/lib/msun/i387/s_remquo.S,v 1.1 2005/03/25 04:40:44 das Exp $"); 
+__FBSDID("$FreeBSD: src/lib/msun/i387/s_remquo.S,v 1.1 2005/03/25 04:40:44 das Exp $");
 	
-ENTRY(remquo)
+STDENTRY(remquo)
 	fldl	12(%esp)
 	fldl	4(%esp)
Index: /trunk/src/emx/src/lib/msun/i387/s_remquof.S
===================================================================
--- /trunk/src/emx/src/lib/msun/i387/s_remquof.S	(revision 2015)
+++ /trunk/src/emx/src/lib/msun/i387/s_remquof.S	(revision 2016)
@@ -30,7 +30,7 @@
 
 #include <machine/asm.h>
-__FBSDID("$FreeBSD: src/lib/msun/i387/s_remquof.S,v 1.1 2005/03/25 04:40:44 das Exp $"); 
+__FBSDID("$FreeBSD: src/lib/msun/i387/s_remquof.S,v 1.1 2005/03/25 04:40:44 das Exp $");
 	
-ENTRY(remquof)
+STDENTRY(remquof)
 	flds	8(%esp)
 	flds	4(%esp)
Index: /trunk/src/emx/src/lib/msun/i387/s_rint.S
===================================================================
--- /trunk/src/emx/src/lib/msun/i387/s_rint.S	(revision 2015)
+++ /trunk/src/emx/src/lib/msun/i387/s_rint.S	(revision 2016)
@@ -38,5 +38,5 @@
 RCSID("$FreeBSD: src/lib/msun/i387/s_rint.S,v 1.6 1999/08/28 00:06:13 peter Exp $")
 
-ENTRY(rint)
+STDENTRY(rint)
 	fldl	4(%esp)
 	frndint
Index: /trunk/src/emx/src/lib/msun/i387/s_rintf.S
===================================================================
--- /trunk/src/emx/src/lib/msun/i387/s_rintf.S	(revision 2015)
+++ /trunk/src/emx/src/lib/msun/i387/s_rintf.S	(revision 2016)
@@ -9,5 +9,5 @@
 /* RCSID("$NetBSD: s_rintf.S,v 1.3 1995/05/09 00:17:22 jtc Exp $") */
 
-ENTRY(rintf)
+STDENTRY(rintf)
 	flds	4(%esp)
 	frndint
Index: /trunk/src/emx/src/lib/msun/i387/s_scalbn.S
===================================================================
--- /trunk/src/emx/src/lib/msun/i387/s_scalbn.S	(revision 2015)
+++ /trunk/src/emx/src/lib/msun/i387/s_scalbn.S	(revision 2016)
@@ -38,5 +38,5 @@
 RCSID("$FreeBSD: src/lib/msun/i387/s_scalbn.S,v 1.7 1999/08/28 00:06:13 peter Exp $")
 
-ENTRY(scalbn)
+STDENTRY(scalbn)
 	fildl	12(%esp)
 	fldl	4(%esp)
Index: /trunk/src/emx/src/lib/msun/i387/s_scalbnf.S
===================================================================
--- /trunk/src/emx/src/lib/msun/i387/s_scalbnf.S	(revision 2015)
+++ /trunk/src/emx/src/lib/msun/i387/s_scalbnf.S	(revision 2016)
@@ -9,5 +9,5 @@
 /* RCSID("$NetBSD: s_scalbnf.S,v 1.4 1999/01/02 05:15:40 kristerw Exp $") */
 
-ENTRY(scalbnf)
+STDENTRY(scalbnf)
 	fildl	8(%esp)
 	flds	4(%esp)
@@ -16,4 +16,4 @@
 	ret
 
-.globl CNAME(ldexpf)
-.set	CNAME(ldexpf),CNAME(scalbnf)
+.globl STDCNAME(ldexpf)
+.set	STDCNAME(ldexpf),STDCNAME(scalbnf)
Index: /trunk/src/emx/src/lib/msun/i387/s_scalbnl.S
===================================================================
--- /trunk/src/emx/src/lib/msun/i387/s_scalbnl.S	(revision 2015)
+++ /trunk/src/emx/src/lib/msun/i387/s_scalbnl.S	(revision 2016)
@@ -9,5 +9,5 @@
 /* RCSID("$NetBSD: s_scalbnf.S,v 1.4 1999/01/02 05:15:40 kristerw Exp $") */
 
-ENTRY(scalbnl)
+STDENTRY(scalbnl)
 	fildl	16(%esp)
 	fldt	4(%esp)
@@ -16,4 +16,4 @@
 	ret
 
-.globl CNAME(ldexpl)
-.set	CNAME(ldexpl),CNAME(scalbnl)
+.globl STDCNAME(ldexpl)
+.set	STDCNAME(ldexpl),STDCNAME(scalbnl)
Index: /trunk/src/emx/src/lib/msun/i387/s_sin.S
===================================================================
--- /trunk/src/emx/src/lib/msun/i387/s_sin.S	(revision 2015)
+++ /trunk/src/emx/src/lib/msun/i387/s_sin.S	(revision 2016)
@@ -38,5 +38,5 @@
 RCSID("$FreeBSD: src/lib/msun/i387/s_sin.S,v 1.6 1999/08/28 00:06:14 peter Exp $")
 
-ENTRY(sin)
+STDENTRY(sin)
 	fldl	4(%esp)
 	fsin
Index: /trunk/src/emx/src/lib/msun/i387/s_tan.S
===================================================================
--- /trunk/src/emx/src/lib/msun/i387/s_tan.S	(revision 2015)
+++ /trunk/src/emx/src/lib/msun/i387/s_tan.S	(revision 2016)
@@ -38,5 +38,5 @@
 RCSID("$FreeBSD: src/lib/msun/i387/s_tan.S,v 1.6 1999/08/28 00:06:14 peter Exp $")
 
-ENTRY(tan)
+STDENTRY(tan)
 	fldl	4(%esp)
 	fptan
Index: /trunk/src/emx/src/lib/msun/i387/s_trunc.S
===================================================================
--- /trunk/src/emx/src/lib/msun/i387/s_trunc.S	(revision 2015)
+++ /trunk/src/emx/src/lib/msun/i387/s_trunc.S	(revision 2016)
@@ -7,5 +7,5 @@
 __FBSDID("$FreeBSD: src/lib/msun/i387/s_trunc.S,v 1.1 2005/04/16 21:12:55 das Exp $")
 
-ENTRY(trunc)
+STDENTRY(trunc)
 	pushl	%ebp
 	movl	%esp,%ebp
Index: /trunk/src/emx/src/lib/msun/i387/s_truncf.S
===================================================================
--- /trunk/src/emx/src/lib/msun/i387/s_truncf.S	(revision 2015)
+++ /trunk/src/emx/src/lib/msun/i387/s_truncf.S	(revision 2016)
@@ -7,5 +7,5 @@
 __FBSDID("$FreeBSD: src/lib/msun/i387/s_truncf.S,v 1.1 2005/04/16 21:12:55 das Exp $")
 
-ENTRY(truncf)
+STDENTRY(truncf)
 	pushl	%ebp
 	movl	%esp,%ebp
Index: /trunk/src/emx/src/lib/msun/i387/s_truncl.S
===================================================================
--- /trunk/src/emx/src/lib/msun/i387/s_truncl.S	(revision 2015)
+++ /trunk/src/emx/src/lib/msun/i387/s_truncl.S	(revision 2016)
@@ -7,5 +7,5 @@
 __FBSDID("$FreeBSD: src/lib/msun/i387/s_truncl.S,v 1.1 2005/04/16 21:12:55 das Exp $")
 
-ENTRY(truncl)
+STDENTRY(truncl)
 	pushl	%ebp
 	movl	%esp,%ebp