Index: trunk/kBuild/sdks/DXSDKAMD64.kmk
===================================================================
--- trunk/kBuild/sdks/DXSDKAMD64.kmk	(revision 2017)
+++ trunk/kBuild/sdks/DXSDKAMD64.kmk	(revision 2018)
@@ -6,5 +6,4 @@
 #
 # Copyright (c) 2006-2008 knut st. osmundsen <bird-kBuild-spam@anduin.net>
-#
 #
 # This file is part of kBuild.
@@ -26,6 +25,6 @@
 #
 # As a special exception you are granted permission to include this file, via
-# the kmk include directive, as you wish without this in itself causing the 
-# resulting makefile, program or whatever to be covered by the GPL license. 
+# the kmk include directive, as you wish without this in itself causing the
+# resulting makefile, program or whatever to be covered by the GPL license.
 # This exception does not however invalidate any other reasons why the makefile,
 # program, whatever should not be covered the GPL.
Index: trunk/kBuild/subheader.kmk
===================================================================
--- trunk/kBuild/subheader.kmk	(revision 2017)
+++ trunk/kBuild/subheader.kmk	(revision 2018)
@@ -29,4 +29,5 @@
 # This exception does not however invalidate any other reasons why the makefile,
 # program, whatever should not be covered the GPL.
+#
 #
 
Index: trunk/kBuild/tools/FLEX.kmk
===================================================================
--- trunk/kBuild/tools/FLEX.kmk	(revision 2017)
+++ trunk/kBuild/tools/FLEX.kmk	(revision 2018)
@@ -23,4 +23,12 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 #
+#
+# As a special exception you are granted permission to include this file, via
+# the kmk include directive, as you wish without this in itself causing the
+# resulting makefile, program or whatever to be covered by the GPL license.
+# This exception does not however invalidate any other reasons why the makefile,
+# program, whatever should not be covered the GPL.
+#
+#
 
 TOOL_FLEX = flex
Index: trunk/kBuild/tools/GXX3.kmk
===================================================================
--- trunk/kBuild/tools/GXX3.kmk	(revision 2017)
+++ trunk/kBuild/tools/GXX3.kmk	(revision 2018)
@@ -6,5 +6,4 @@
 #
 # Copyright (c) 2004-2008 knut st. osmundsen <bird-kBuild-spam@anduin.net>
-#
 #
 # This file is part of kBuild.
Index: trunk/kBuild/tools/GXX3OMF.kmk
===================================================================
--- trunk/kBuild/tools/GXX3OMF.kmk	(revision 2017)
+++ trunk/kBuild/tools/GXX3OMF.kmk	(revision 2018)
@@ -6,5 +6,4 @@
 #
 # Copyright (c) 2004-2008 knut st. osmundsen <bird-kBuild-spam@anduin.net>
-#
 #
 # This file is part of kBuild.
@@ -26,6 +25,6 @@
 #
 # As a special exception you are granted permission to include this file, via
-# the kmk include directive, as you wish without this in itself causing the 
-# resulting makefile, program or whatever to be covered by the GPL license. 
+# the kmk include directive, as you wish without this in itself causing the
+# resulting makefile, program or whatever to be covered by the GPL license.
 # This exception does not however invalidate any other reasons why the makefile,
 # program, whatever should not be covered the GPL.
Index: trunk/kBuild/tools/GXX4MACHO.kmk
===================================================================
--- trunk/kBuild/tools/GXX4MACHO.kmk	(revision 2017)
+++ trunk/kBuild/tools/GXX4MACHO.kmk	(revision 2018)
@@ -6,5 +6,4 @@
 #
 # Copyright (c) 2004-2008 knut st. osmundsen <bird-kBuild-spam@anduin.net>
-#
 #
 # This file is part of kBuild.
@@ -26,6 +25,6 @@
 #
 # As a special exception you are granted permission to include this file, via
-# the kmk include directive, as you wish without this in itself causing the 
-# resulting makefile, program or whatever to be covered by the GPL license. 
+# the kmk include directive, as you wish without this in itself causing the
+# resulting makefile, program or whatever to be covered by the GPL license.
 # This exception does not however invalidate any other reasons why the makefile,
 # program, whatever should not be covered the GPL.
Index: trunk/kBuild/tools/MINGW32.kmk
===================================================================
--- trunk/kBuild/tools/MINGW32.kmk	(revision 2017)
+++ trunk/kBuild/tools/MINGW32.kmk	(revision 2018)
@@ -6,5 +6,4 @@
 #
 # Copyright (c) 2004-2008 knut st. osmundsen <bird-kBuild-spam@anduin.net>
-#
 #
 # This file is part of kBuild.
Index: trunk/kBuild/tools/TARGZ.kmk
===================================================================
--- trunk/kBuild/tools/TARGZ.kmk	(revision 2017)
+++ trunk/kBuild/tools/TARGZ.kmk	(revision 2018)
@@ -6,5 +6,4 @@
 #
 # Copyright (c) 2006-2008 knut st. osmundsen <bird-kBuild-spam@anduin.net>
-#
 #
 # This file is part of kBuild.
@@ -26,6 +25,6 @@
 #
 # As a special exception you are granted permission to include this file, via
-# the kmk include directive, as you wish without this in itself causing the 
-# resulting makefile, program or whatever to be covered by the GPL license. 
+# the kmk include directive, as you wish without this in itself causing the
+# resulting makefile, program or whatever to be covered by the GPL license.
 # This exception does not however invalidate any other reasons why the makefile,
 # program, whatever should not be covered the GPL.
Index: trunk/kBuild/tools/VAC308.kmk
===================================================================
--- trunk/kBuild/tools/VAC308.kmk	(revision 2017)
+++ trunk/kBuild/tools/VAC308.kmk	(revision 2018)
@@ -6,5 +6,4 @@
 #
 # Copyright (c) 2004-2008 knut st. osmundsen <bird-kBuild-spam@anduin.net>
-#
 #
 # This file is part of kBuild.
@@ -26,6 +25,6 @@
 #
 # As a special exception you are granted permission to include this file, via
-# the kmk include directive, as you wish without this in itself causing the 
-# resulting makefile, program or whatever to be covered by the GPL license. 
+# the kmk include directive, as you wish without this in itself causing the
+# resulting makefile, program or whatever to be covered by the GPL license.
 # This exception does not however invalidate any other reasons why the makefile,
 # program, whatever should not be covered the GPL.
Index: trunk/kBuild/tools/VCC80.kmk
===================================================================
--- trunk/kBuild/tools/VCC80.kmk	(revision 2017)
+++ trunk/kBuild/tools/VCC80.kmk	(revision 2018)
@@ -6,5 +6,4 @@
 #
 # Copyright (c) 2004-2008 knut st. osmundsen <bird-kBuild-spam@anduin.net>
-#
 #
 # This file is part of kBuild.
@@ -26,6 +25,6 @@
 #
 # As a special exception you are granted permission to include this file, via
-# the kmk include directive, as you wish without this in itself causing the 
-# resulting makefile, program or whatever to be covered by the GPL license. 
+# the kmk include directive, as you wish without this in itself causing the
+# resulting makefile, program or whatever to be covered by the GPL license.
 # This exception does not however invalidate any other reasons why the makefile,
 # program, whatever should not be covered the GPL.
Index: trunk/kBuild/tools/VCC80AMD64.kmk
===================================================================
--- trunk/kBuild/tools/VCC80AMD64.kmk	(revision 2017)
+++ trunk/kBuild/tools/VCC80AMD64.kmk	(revision 2018)
@@ -6,5 +6,4 @@
 #
 # Copyright (c) 2004-2008 knut st. osmundsen <bird-kBuild-spam@anduin.net>
-#
 #
 # This file is part of kBuild.
@@ -26,6 +25,6 @@
 #
 # As a special exception you are granted permission to include this file, via
-# the kmk include directive, as you wish without this in itself causing the 
-# resulting makefile, program or whatever to be covered by the GPL license. 
+# the kmk include directive, as you wish without this in itself causing the
+# resulting makefile, program or whatever to be covered by the GPL license.
 # This exception does not however invalidate any other reasons why the makefile,
 # program, whatever should not be covered the GPL.
Index: trunk/kBuild/tools/WGET.kmk
===================================================================
--- trunk/kBuild/tools/WGET.kmk	(revision 2017)
+++ trunk/kBuild/tools/WGET.kmk	(revision 2018)
@@ -6,5 +6,4 @@
 #
 # Copyright (c) 2006-2008 knut st. osmundsen <bird-kBuild-spam@anduin.net>
-#
 #
 # This file is part of kBuild.
@@ -26,6 +25,6 @@
 #
 # As a special exception you are granted permission to include this file, via
-# the kmk include directive, as you wish without this in itself causing the 
-# resulting makefile, program or whatever to be covered by the GPL license. 
+# the kmk include directive, as you wish without this in itself causing the
+# resulting makefile, program or whatever to be covered by the GPL license.
 # This exception does not however invalidate any other reasons why the makefile,
 # program, whatever should not be covered the GPL.
Index: trunk/kBuild/units/lex.kmk
===================================================================
--- trunk/kBuild/units/lex.kmk	(revision 2017)
+++ trunk/kBuild/units/lex.kmk	(revision 2018)
@@ -22,4 +22,11 @@
 # along with kBuild; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
+#
+#
+# As a special exception you are granted permission to include this file, via
+# the kmk include directive, as you wish without this in itself causing the
+# resulting makefile, program or whatever to be covered by the GPL license.
+# This exception does not however invalidate any other reasons why the makefile,
+# program, whatever should not be covered the GPL.
 #
 #
Index: trunk/kBuild/units/qt3.kmk
===================================================================
--- trunk/kBuild/units/qt3.kmk	(revision 2017)
+++ trunk/kBuild/units/qt3.kmk	(revision 2018)
@@ -24,4 +24,12 @@
 #
 #
+# As a special exception you are granted permission to include this file, via
+# the kmk include directive, as you wish without this in itself causing the
+# resulting makefile, program or whatever to be covered by the GPL license.
+# This exception does not however invalidate any other reasons why the makefile,
+# program, whatever should not be covered the GPL.
+#
+#
+
 
 ifdef UNIT_qt3
@@ -224,7 +232,7 @@
     	)))
    ifeq ($(PATH_TOOL_QT3_BIN),)
-    # If we couldn't find the qt3 specific tool qm2ts, debian and other skip 
+    # If we couldn't find the qt3 specific tool qm2ts, debian and other skip
     # this (thanks a bundle). Try with look for 'moc' with a '-qt3' extension,
-    # then for just moc. In the latter case don't search /usr[/local]/bin to 
+    # then for just moc. In the latter case don't search /usr[/local]/bin to
     # void finding the qt4 tools and messing up.
     ifeq ($(TOOL_QT3_BIN_SUFF),)
Index: trunk/kBuild/units/qt4.kmk
===================================================================
--- trunk/kBuild/units/qt4.kmk	(revision 2017)
+++ trunk/kBuild/units/qt4.kmk	(revision 2018)
@@ -24,4 +24,12 @@
 #
 #
+# As a special exception you are granted permission to include this file, via
+# the kmk include directive, as you wish without this in itself causing the
+# resulting makefile, program or whatever to be covered by the GPL license.
+# This exception does not however invalidate any other reasons why the makefile,
+# program, whatever should not be covered the GPL.
+#
+#
+
 
 ifdef UNIT_qt4